module Playground

import Control.ST
import Data.Vect
import MultiSigWallet
import Util

%default total
%access public export

user1 : PublicIdentity
user1 = MkPublicIdentity 1

user2 : PublicIdentity
user2 = MkPublicIdentity 2

user3 : PublicIdentity
user3 = MkPublicIdentity 3

nonUser1 : PublicIdentity
nonUser1 = MkPublicIdentity 4

nonUser2 : PublicIdentity
nonUser2 = MkPublicIdentity 5


owners1 : Vect 1 PublicIdentity
owners1 = [ user1 ]

owners3 : Vect 3 PublicIdentity
owners3 = [ user1, user2, user3 ]


nonOwners : Vect 3 PublicIdentity
nonOwners = [ user1, nonUser1, user3 ]


address : Address
address = 1

---------------------
sampleFlow1 : ST m NanoGram []

sampleFlow1 = do
    wallet <- createWallet address (MkNonZeroNat 2) owners3
    depositToWallet wallet 10
    walletState <- read wallet
    let
        decision = quorumReached (walletState) owners3
    case decision of
        (Yes prf) => case walletState of
            MkMultiSigWalletState => do
                withdrawFromWallet wallet 10 owners3 prf
                balance <- getWalletBalance wallet
                Control.ST.delete wallet
                pure balance
        (No contra) => do
            balance <- getWalletBalance wallet
            Control.ST.delete wallet
            pure balance



res : NanoGram
res = runPure (sampleFlow1)
